stages:
  - build
  - linter
  - test

build:
  stage: build
  image: maven
  script:
    - chmod +x mvnw
    - ./mvnw package
  artifacts:
    paths:
      - target/demo-0.0.1-SNAPSHOT.jar

linter:
  stage: linter
  image: maven
  script:
    - chmod +x mvnw
    - ./mvnw spotbugs:spotbugs
  artifacts:
    paths:
      - target/demo-0.0.1-SNAPSHOT.jar

test:
  stage: test
  image: maven
  parallel:
    matrix:
      - TEST_NAME: ForumDAOTest
      - TEST_NAME: UserDAOTest
      - TEST_NAME: PostDAOTest
      - TEST_NAME: ThreadDAOTest
  script:
    - chmod +x mvnw
    - ./mvnw test -Dtest=$TEST_NAME
